####################
# Copyright (c) 2021, Perceptive Automation, LLC. All rights reserved.
# http://www.indigodomo.com
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#
# IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
#
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
# IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
####################

####################
## IMPORTS
import cherrypy
from cherrypy import _cperror

from indigopy import indigoconn as ic
from indigopy import indigodb as idb
from indigopy.basereqhandler import BaseRequestHandler

def PluginName():
    return u"Variable URL Redirect"

def ShowOnControlPageList():
    return False

class MyRequestHandler(BaseRequestHandler):
    def __init__(self, logger, deprecatedDebugLogFunc):
        BaseRequestHandler.__init__(self, logger, deprecatedDebugLogFunc)

    def index(self, name=None):
        logmessage = u"Redirect from Variable usage: http://host:port/variable_url_redirect/redirect?name=SOMEVARIABLENAME\n\n"
        self._Log(logmessage)
        cherrypy.response.headers['Content-Type'] = 'text/plain'
        return logmessage
    index.exposed = True

    def redirect(self, name=None, submit=None):
        if not (submit):
            theVariable = cherrypy.server.indigoDb.GetVariable(cherrypy.server.indigoConn, name)
            raise cherrypy.HTTPRedirect(theVariable.value)          
    redirect.exposed = True
